"use strict";
/**************************************************************************************************

	This software package is released and distributed under an Unlicense.

	Eclipsed Moon Test

		A component of the test package for the Eclipsed Moon add-on/extension targeted exclusively
		for the Pale Moon™ browser.

											―――――――――――――

											The Unlicense

	This is free and unencumbered software released into the public domain.

	Anyone is free to copy, modify, publish, use, compile, sell, or distribute this software,
	either in source code form or as a compiled binary, for any purpose, commercial or non-
	commercial, and by any means.

	In jurisdictions that recognize copyright laws, the author or authors of this software dedicate
	any and all copyright interest in this software to the public domain. I or we make this
	dedication for the benefit of the public at large and to the detriment of my or our heirs and
	successors. I or we intend this dedication to be an overt act of relinquishment in perpetuity
	of all present and future rights to this software under copyright law.

	THIS SOFTWARE IS PROVIDED BY THE THE AUTHOR OR AUTHORS “AS IS” AND ANY EXPRESS OR IMPLIED
	WARRANTIES (INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS
	FOR A PARTICULAR PURPOSE, AND NONINFRINGEMENT) ARE DISCLAIMED. IN NO EVENT SHALL THE AUTHOR OR
	AUTHORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
	DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF
	USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY,
	WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN
	ANY WAY FROM, OUT OF, OR IN CONNECTION WITH THIS SOFTWARE, OR THE USE OF OR OTHER DEALINGS WITH
	THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

**************************************************************************************************/

document.addEventListener( "DOMContentLoaded", doPrep, false );
window.addEventListener( "load", doStats, false );

const ABSOLUTE_MAX = 1000, DEFAULT_MAX = 50;

var $_GET = {};
$_GET.fill = function()
{
	if( window.location.search.length < 2 ){ return; }
	let q = window.location.search.substr( 1 );
	if( q.indexOf( "=" ) === -1 )
	{
		this[q] = "";
		return;
	}
	if( q.indexOf( "&" ) === -1 )
	{
		q = q.split( "=" );
		this[q[0]] = q[1].toString();
		return;
	}
	q = q.split( "&" );
	for( let i = 0, p; i < q.length; i++ )
	{
		p = q[i].split( "=" );
		this[p[0]] = p[1].toString();
	}
};
$_GET.empty = function()
{
	for( let p in this )
	{
		if( typeof( this[p] ) === "string" ){ return false; }
	}
	return true;
};
$_GET.dump = function()
{
	let s = "";
	for( let p in this )
	{
		if( typeof( this[p] ) === "string" ){ s += p + " = " + this[p] + "\n"; }
	}
	alert( s );
};


function doPrep( event )
{
	$_GET.fill();
}

function doStats( event )
{
	let max = document.getElementById( "max" ), iMax = DEFAULT_MAX;
	let cnt = document.getElementById( "cnt" ), iCnt = 0;
	let chr = document.getElementById( "chr" ), iChr = 0;
	let fox = document.getElementById( "fox" ), iFox = 0;
	let viv = document.getElementById( "viv" ), iViv = 0;
	let win = document.getElementById( "win" ), iWin = 0;
	let mac = document.getElementById( "mac" ), iMac = 0;
	let nux = document.getElementById( "nux" ), iNux = 0;
	let chro = document.getElementById( "chro" );
	let foxo = document.getElementById( "foxo" );
	let vivo = document.getElementById( "vivo" );
	let wino = document.getElementById( "wino" );
	let maco = document.getElementById( "maco" );
	let nuxp = document.getElementById( "nuxo" );
	let ua = window.navigator.userAgent;

	if( $_GET.empty() )
	{
		if( !window.confirm( "Is Eclipsed Moon mode set to “Page”?\nIf not, please Cancel." ) ){ return; }
	}
	else
	{
		if( typeof( $_GET["runs"] ) === "string" )
		{
			if( !window.confirm( "Is Eclipsed Moon mode set to “Page”?\nIf not, please Cancel." ) ){ return; }
			iMax = parseInt( $_GET["runs"], 10 );
		}
		else
		{
			if( typeof( $_GET["max"] ) === "string" ){ iMax = parseInt( $_GET["max"], 10 ); }
			if( typeof( $_GET["cnt"] ) === "string" ){ iCnt = parseInt( $_GET["cnt"], 10 ); }
			if( typeof( $_GET["chr"] ) === "string" ){ iChr = parseInt( $_GET["chr"], 10 ); }
			if( typeof( $_GET["fox"] ) === "string" ){ iFox = parseInt( $_GET["fox"], 10 ); }
			if( typeof( $_GET["viv"] ) === "string" ){ iViv = parseInt( $_GET["viv"], 10 ); }
			if( typeof( $_GET["win"] ) === "string" ){ iWin = parseInt( $_GET["win"], 10 ); }
			if( typeof( $_GET["mac"] ) === "string" ){ iMac = parseInt( $_GET["mac"], 10 ); }
			if( typeof( $_GET["nux"] ) === "string" ){ iNux = parseInt( $_GET["nux"], 10 ); }
		}
	}
		
	if( iMax > ABSOLUTE_MAX ){ iMax = ABSOLUTE_MAX; }

	iCnt++;

	if( /Vivaldi/.test( ua ) ){ iViv++; }
	else if( /Chrome/.test( ua ) ){ iChr++; }
	else if( /Firefox/.test( ua ) ){ iFox++; }
	else { iMax = ua; }

	if( /Windows/.test( ua ) ){ iWin++; }
	else if( /Macintosh/.test( ua ) ){ iMac++; }
	else if( /Linux/.test( ua ) ){ iNux++; }
	else { iMax = ua; }

	cnt.value = iCnt.toString();
	chr.value = iChr.toString();
	fox.value = iFox.toString();
	viv.value = iViv.toString();
	win.value = iWin.toString();
	mac.value = iMac.toString();
	nux.value = iNux.toString();
	chro.firstChild.nodeValue = ( 100 * iChr / iCnt ).toFixed( 1 );
	foxo.firstChild.nodeValue = ( 100 * iFox / iCnt ).toFixed( 1 );
	vivo.firstChild.nodeValue = ( 100 * iViv / iCnt ).toFixed( 1 );
	wino.firstChild.nodeValue = ( 100 * iWin / iCnt ).toFixed( 1 );
	maco.firstChild.nodeValue = ( 100 * iMac / iCnt ).toFixed( 1 );
	nuxo.firstChild.nodeValue = ( 100 * iNux / iCnt ).toFixed( 1 );

	if( isNaN( iMax ) )
	{
		max.value = iMax;
		max.parentNode.parentNode.className = "oops";
		max.parentNode.style.width = Math.round( 15 * iMax.length / 32 ).toString() + "em";
		return;
	}
	else
	{
		max.value = iMax.toString();
	}

	if( iCnt >= iMax ){ return; }
	window.setTimeout( doLoop, 100, max, cnt, chr, fox, viv, win, mac, nux );
}

function doLoop( max, cnt, chr, fox, viv, win, mac, nux )
{
	let q = "max=" + max.value + "&cnt=" + cnt.value + "&chr=" + chr.value + "&fox=" + fox.value + "&viv=" + viv.value + "&win=" + win.value + "&mac=" + mac.value + "&nux=" + nux.value;
	window.location.search = q;
}
