<?php
/**************************************************************************************************

	This software package is released and distributed under an Unlicense.

	Eclipsed Moon Test

		A component of the test package for the Eclipsed Moon add-on/extension targeted exclusively
		for the Pale Moon™ browser.

											―――――――――――――

											The Unlicense

	This is free and unencumbered software released into the public domain.

	Anyone is free to copy, modify, publish, use, compile, sell, or distribute this software,
	either in source code form or as a compiled binary, for any purpose, commercial or non-
	commercial, and by any means.

	In jurisdictions that recognize copyright laws, the author or authors of this software dedicate
	any and all copyright interest in this software to the public domain. I or we make this
	dedication for the benefit of the public at large and to the detriment of my or our heirs and
	successors. I or we intend this dedication to be an overt act of relinquishment in perpetuity
	of all present and future rights to this software under copyright law.

	THIS SOFTWARE IS PROVIDED BY THE THE AUTHOR OR AUTHORS “AS IS” AND ANY EXPRESS OR IMPLIED
	WARRANTIES (INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS
	FOR A PARTICULAR PURPOSE, AND NONINFRINGEMENT) ARE DISCLAIMED. IN NO EVENT SHALL THE AUTHOR OR
	AUTHORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
	DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF
	USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY,
	WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN
	ANY WAY FROM, OUT OF, OR IN CONNECTION WITH THIS SOFTWARE, OR THE USE OF OR OTHER DEALINGS WITH
	THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

**************************************************************************************************/

	define( 'ABSOLUTE_MAX', 1000 );
	define( 'DEFAULT_MAX', 50 );

	$max = DEFAULT_MAX;
	$cnt = 0;
	$chr = 0;
	$fox = 0;
	$viv = 0;
	$win = 0;
	$mac = 0;
	$nux = 0;
	if( $_SERVER['REQUEST_METHOD'] === 'POST' )
	{
		if( !empty( $_POST['max'] ) && isset( $_POST['max'] ) ){ $max = $_POST['max']; }
		if( !empty( $_POST['cnt'] ) && isset( $_POST['cnt'] ) ){ $cnt = $_POST['cnt']; }
		if( !empty( $_POST['chr'] ) && isset( $_POST['chr'] ) ){ $chr = $_POST['chr']; }
		if( !empty( $_POST['fox'] ) && isset( $_POST['fox'] ) ){ $fox = $_POST['fox']; }
		if( !empty( $_POST['viv'] ) && isset( $_POST['viv'] ) ){ $viv = $_POST['viv']; }
		if( !empty( $_POST['win'] ) && isset( $_POST['win'] ) ){ $win = $_POST['win']; }
		if( !empty( $_POST['mac'] ) && isset( $_POST['mac'] ) ){ $mac = $_POST['mac']; }
		if( !empty( $_POST['nux'] ) && isset( $_POST['nux'] ) ){ $nux = $_POST['nux']; }
	}
	else
	{
		if( !empty( $_GET['runs'] ) && isset( $_GET['runs'] ) ){ $max = $_GET['runs']; }
	}
	if( $max > ABSOLUTE_MAX ){ $max = ABSOLUTE_MAX; }

	$ua = $_SERVER['HTTP_USER_AGENT'];
	$cnt++;
	if( strpos( $ua, "Vivaldi" ) !== FALSE )
	{
		$viv++;
	}
	elseif( strpos( $ua, "Chrome" ) !== FALSE )
	{
		$chr++;
	}
	elseif( strpos( $ua, "Firefox" ) !== FALSE )
	{
		$fox++;
	}
	else
	{
		$max = $ua;
	}
	$vivo = sprintf( "%.1f", ( $viv * 100 ) / $cnt );
	$chro = sprintf( "%.1f", ( $chr * 100 ) / $cnt );
	$foxo = sprintf( "%.1f", ( $fox * 100 ) / $cnt );

	if( strpos( $ua, "Windows" ) !== FALSE )
	{
		$win++;
	}
	elseif( strpos( $ua, "Macintosh" ) !== FALSE )
	{
		$mac++;
	}
	elseif( strpos( $ua, "Linux" ) !== FALSE )
	{
		$nux++;
	}
	else
	{
		$max = $ua;
	}
	$wino = sprintf( "%.1f", ( $win * 100 ) / $cnt );
	$maco = sprintf( "%.1f", ( $mac * 100 ) / $cnt );
	$nuxo = sprintf( "%.1f", ( $nux * 100 ) / $cnt );

	header( 'Content-Type: application/xhtml+xml; charset=UTF-8' );
	echo '<?xml version="1.0" encoding="UTF-8"?>' . PHP_EOL;
?>
<!DOCTYPE html>
<html lang="en-US" xmlns="http://www.w3.org/1999/xhtml" xmlns:xml="http://www.w3.org/XML/1998/namespace" xml:lang="en-US">
<head>
	<title>Eclipsed Moon Test</title>

	<link rel="icon" type="image/png" href="imgs/eclipsed_moon_test.png" />

	<link rel="stylesheet" type="text/css" href="skin/eclipsed_moon_test.css" media="screen" />
	<script type="application/javascript" src="apps/eclipsed_moon_test-php.js" charset="UTF-8"></script>
</head>
<body>
	<main>
		<header><h1>Eclipsed Moon Test</h1></header>
		<form id="statistics" action="" method="post" accept-charset="UTF-8">
			<header><h1>Statistics</h1></header>
			<fieldset>
				<div><input id="utf" name="utf" type="hidden" value="✓" /><label><span id="run">Runs</span><input id="cnt" name="cnt" type="text" value="<?=$cnt?>" /></label><span>Error:<span><input id="max" name="max" type="text" value="<?=$max?>" /></span></span></div>
			</fieldset>
			<fieldset>
				<legend>Browsers</legend>
				<div><label><span>Chrome</span><input id="chr" name="chr" value="<?=$chr?>" /></label><output><?=$chro?></output></div>
				<div><label><span>Firefox</span><input id="fox" name="fox" value="<?=$fox?>" /></label><output><?=$foxo?></output></div>
				<div><label><span>Vivaldi</span><input id="viv" name="viv" value="<?=$viv?>" /></label><output><?=$vivo?></output></div>
			</fieldset>
			<fieldset>
				<legend>Operating Systems</legend>
				<div><label><span>Windows</span><input id="win" name="win" value="<?=$win?>" /></label><output><?=$wino?></output></div>
				<div><label><span>Mac OS X</span><input id="mac" name="mac" value="<?=$mac?>" /></label><output><?=$maco?></output></div>
				<div><label><span>Linux</span><input id="nux" name="nux" value="<?=$nux?>" /></label><output><?=$nuxo?></output></div>
			</fieldset>
		</form>
	</main>
</body>
</html>
